@echo off
set GRAB_VERSION=1.0.0
@rem set environment variables
call mode con cols=380

setlocal enabledelayedexpansion  

@rem set file name
for /f "tokens=2 delims==" %%a in ('wmic path win32_operatingsystem get LocalDateTime /value') do (
  set t=%%a
)
set today=%t:~0,4%%t:~4,2%%t:~6,2%
set hostName=%computername%
SET LOG_FILE=Windows_%hostName%_%today%.data

@rem When commands added, need to modify Obj_Length
SET Obj_Length=72
SET /a Loop_Time=%Obj_Length%+1
SET Obj_Index=1
SET PATH=%PATH%;C:\Program Files\Emulex\Util\OCManager;D:\Program Files\Emulex\Util\OCManager;

@rem Add commands here, does not support comma and equal symbol
@rem Baisc host information
SET Obj[1].CMD=wmic OS get Caption /value
SET Obj[2].CMD=wmic OS get Version /value
SET Obj[3].CMD=wmic OS get CSDVersion /value
SET Obj[4].CMD=wmic OS get BuildNumber /value
SET Obj[5].CMD=wmic COMPUTERSYSTEM get Model /value
SET Obj[6].CMD=wmic COMPUTERSYSTEM get SystemType /value
SET Obj[7].CMD=wmic COMPUTERSYSTEM get Name /value
SET Obj[8].CMD=wmic COMPUTERSYSTEM get manufacturer /value
SET Obj[9].CMD=wmic computersystem get NumberOfProcessors /value
SET Obj[10].CMD=wmic OS get FreePhysicalMemory /value
SET Obj[11].CMD=wmic OS get TotalVisibleMemorySize /value
SET Obj[12].CMD=wmic nicconfig get IPAddress
SET Obj[13].CMD=wmic OS get WindowsDirectory /value
SET Obj[14].CMD=wmic OS get SystemDirectory /value
SET Obj[15].CMD=wmic OS get BootDevice /value
SET Obj[16].CMD=wmic os get SerialNumber /value
SET Obj[17].CMD=wmic scsicontroller
SET Obj[18].CMD=powershell get-hotfix
SET Obj[19].CMD=systeminfo
@rem HBA information
SET Obj[20].CMD=powershell Get-InitiatorPort
SET Obj[21].CMD=winrm e wmi/root/wmi/MSFC_FibrePortHBAAttributes
SET Obj[22].CMD=powershell Get-WmiObject -Class MSFC_FCAdapterHBAAttributes -Namespace root\WMI 
SET Obj[23].CMD=winrm e wmi/root/wmi/MSFC_FCAdapterHBAAttributes
SET Obj[24].CMD=qaucli -v
SET Obj[25].CMD=qaucli -i
SET Obj[26].CMD=qaucli -c
SET Obj[27].CMD=hbacmd listhbas
SET Obj[27].CMDS=hbacmd PortAttributes,hbacmd getdriverparams
SET Obj[27].KEYWORD=^Port.*WWN
@rem Hyper-Metro information
SET Obj[28].CMD=powershell Get-MPIOSetting 
SET Obj[29].CMD=powershell Get-ItemProperty "HKLM:\System\CurrentControlSet\Services\msdsm\Parameters"
@rem UltraPath information
SET Obj[30].CMD=upadm show version
SET Obj[31].CMD=upadm show path
SET Obj[32].CMD=upadm show array
SET Obj[32].PARAM=array_id
SET Obj[33].CMD=upadm show vlun
SET Obj[33].PARAM=id
SET Obj[34].CMD=upadm show vlun
SET Obj[34].ARGNAME=type
SET Obj[34].ARGVALUE=all
SET Obj[34].PARAM=id
@rem Other information
SET Obj[35].CMD=wmic os get csname
SET Obj[36].CMD=mpclaim -e
SET Obj[37].CMD=upadm check status
SET Obj[38].CMD=Reg Query "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Class\{4D36E97B-E325-11CE-BFC1-08002BE10318}" /s /f LinkDownTime /v
SET Obj[39].CMD=Reg Query "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Class\{4D36E97B-E325-11CE-BFC1-08002BE10318}" /s /f MaxRequestHoldTime /v
@rem connection to host
SET Obj[40].CMD=wmic OS get name
SET Obj[41].CMD=wmic NICCONFIG get ipaddress
SET Obj[42].CMD=wmic NICCONFIG get macaddress
SET Obj[43].CMD=wmic os get version
SET Obj[44].CMD=powershell Get-WmiObject -Namespace root\wmi -Class MSiSCSIInitiator_MethodClass
SET Obj[45].CMD=wmic cpu get name /value
@rem get disk information
SET Obj[46].CMD=powershell Get-Disk
SET Obj[47].CMD=powershell Get-PhysicalDisk
SET Obj[48].CMD=powershell Get-InitiatorPort
@rem get WFSC Cluster Information
SET Obj[49].CMD=powershell Get-ClusterResource
SET Obj[50].CMD=powershell Get-ClusterQuorum
SET Obj[51].CMD=powershell Get-ClusterSharedVolume
SET Obj[52].CMD=powershell Get-ClusterSharedVolumeState
SET Obj[53].CMD=powershell Get-Clusternode
SET Obj[54].CMD=powershell Get-ClusterGroup
@rem get Storage Foundation Information
SET obj[55].CMD=hastatus -sum
SET obj[56].CMD=lltstat -l
SET obj[57].CMD=gabconfig -a
SET obj[58].CMD=vxdg list
SET obj[58].KEY=Name
SET obj[59].CMD=hagrp -state
SET obj[60].CMD=hares -state
SET obj[61].CMD=hares -display
SET obj[62].CMD=hagrp -display
SET obj[63].CMD=hasys -list
SET obj[64].CMD=vxprint
SET obj[65].CMD=vxprint -h
SET obj[66].CMD=vxprint -v
SET obj[67].CMD=vxprint -p
SET obj[68].CMD=vxdisk -e list
SET obj[69].CMD=vxdisk list
SET obj[70].CMD=ipconfig /all
SET obj[71].CMD=route print
SET obj[72].CMD=type %windir%\System32\drivers\etc\hosts

@ECHO Begin to get information ...
@ECHO+>%LOG_FILE%

@rem Dealing with single command
:SingleCmdStart
IF %Obj_Index% EQU %Loop_Time% GOTO END

SET Obj_Current.CMD=0
FOR /F "usebackq delims==. tokens=1-3" %%I IN (`SET Obj[%Obj_Index%]`) DO (
  SET Obj_Current.%%J=%%K
)

SET IS_DOS=1
if "%Obj_Current.CMD:wmic=%" NEQ "%Obj_Current.CMD%" (
  SET IS_DOS=0
)
if "%Obj_Current.CMD:powershell=%" NEQ "%Obj_Current.CMD%" (
  SET IS_DOS=0
)

SET CMD_NEW=%Obj_Current.CMD%
if "!Obj[%Obj_Index%].ARGNAME!" NEQ "" (
  SET CMD_NEW=%Obj_Current.CMD% !Obj[%Obj_Index%].ARGNAME!=!Obj[%Obj_Index%].ARGVALUE!
)  

@ECHO ###########################################################################>>%LOG_FILE%
@ECHO StartCmd:%CMD_NEW%>>%LOG_FILE%

if "%IS_DOS%" NEQ "1" (
  for /f "delims=" %%b in ('call %CMD_NEW%') do (
    ECHO+%%~b>>%LOG_FILE% 2>&1
  )
) else (
  call %CMD_NEW%>>%LOG_FILE% 2>&1
)
@ECHO EndCmd:%CMD_NEW%>>%LOG_FILE%

SET /a CAL_PROGRESS=100*%Obj_Index%/%Loop_Time%
@ECHO Progress: %CAL_PROGRESS%%%	Command: %Obj_Current.CMD%

@rem Convert to powershell command prevent command not found
if "!Obj[%Obj_Index%].PARAM!" NEQ "" ( 
    if "!Obj[%Obj_Index%].ARGNAME!" NEQ "" (
      call powershell !Obj_Current.CMD! !Obj[%Obj_Index%].ARGNAME!=!Obj[%Obj_Index%].ARGVALUE!>temp.txt
    ) else (
      call powershell !Obj_Current.CMD!>temp.txt
    )
    for /f "tokens=1 delims= " %%a in ('type temp.txt') do (
      echo %%a|findstr "^[0-9][0-9]*$">nul && (
        if "!Obj[%Obj_Index%].ARGNAME!" NEQ "" (
          SET CMD_WITH_PARAM=!Obj_Current.CMD! !Obj[%Obj_Index%].PARAM!=%%a !Obj[%Obj_Index%].ARGNAME!=!Obj[%Obj_Index%].ARGVALUE!
        ) else (
          SET CMD_WITH_PARAM=!Obj_Current.CMD! !Obj[%Obj_Index%].PARAM!=%%a
          SET CMD_WITH_PARAM=!CMD_WITH_PARAM: array = path !
        )
        
        @ECHO StartCmd:!CMD_WITH_PARAM!>>%LOG_FILE%
        @ECHO          !CMD_WITH_PARAM!
        call powershell !CMD_WITH_PARAM!>>!LOG_FILE! 2>&1
        @ECHO EndCmd:!CMD_WITH_PARAM!>>%LOG_FILE%
      )
    )
   del temp.txt
)

@rem get hba infomation
if "!Obj[%Obj_Index%].CMDS!" NEQ "" ( 
    call !Obj_Current.CMD!>temp.txt
    for /f "tokens=1 delims=*" %%a in ('type temp.txt') do (
      SET KEYWORD=!Obj[%Obj_Index%].KEYWORD!
      echo %%a|findstr "!KEYWORD!">nul && (
        SET LINESTR=%%a
        for /f "tokens=4* delims= " %%i in ("!LINESTR!") do (
          SET WWN=%%i
          for /f "tokens=1,2 delims=," %%m in ("!Obj[%Obj_Index%].CMDS!") do (
            SET CMD_WITH_PARAM=%%m !WWN!
            @ECHO StartCmd:!CMD_WITH_PARAM!>>%LOG_FILE%
            @ECHO                !CMD_WITH_PARAM!
            call powershell !CMD_WITH_PARAM!>>!LOG_FILE! 2>&1
            @ECHO EndCmd:!CMD_WITH_PARAM!>>%LOG_FILE%
            SET CMD_WITH_PARAM=%%n !WWN!
            @ECHO StartCmd:!CMD_WITH_PARAM!>>%LOG_FILE%
            @ECHO               !CMD_WITH_PARAM!
            call powershell !CMD_WITH_PARAM!>>!LOG_FILE! 2>&1
            @ECHO EndCmd:!CMD_WITH_PARAM!>>%LOG_FILE%
         )
       )
      )
    )
   del temp.txt
)

if "!Obj[%Obj_Index%].KEY!" NEQ "" (
    call !Obj[%Obj_Index%].CMD!|findstr "Name">temp.txt
    for /f "skip=1 tokens=2 delims=: " %%i in ('type temp.txt') do (
        SET var=%%i
        setlocal enabledelayedexpansion
        SET cName=!var:~0,-1!
        SET CMD_WITH_PARAM=vxdg -g !cName! info
        @ECHO ###########################################################################>>%LOG_FILE%
        @ECHO+>>%LOG_FILE%
        @ECHO+>>%LOG_FILE%
        @ECHO+>>%LOG_FILE%
        @ECHO ###########################################################################>>%LOG_FILE%
        @ECHO StartCmd:!CMD_WITH_PARAM!>>%LOG_FILE%
        @ECHO                !CMD_WITH_PARAM!
        call !CMD_WITH_PARAM!>>!LOG_FILE! 2>&1
        @ECHO EndCmd:!CMD_WITH_PARAM!>>%LOG_FILE%
    )
    del temp.txt
)

@ECHO ###########################################################################>>%LOG_FILE%
@ECHO+>>%LOG_FILE%
@ECHO+>>%LOG_FILE%
@ECHO+>>%LOG_FILE%

SET /A Obj_Index=%Obj_Index% + 1
GOTO SingleCmdStart
:END
@ECHO ###########################################################################>>%LOG_FILE%
@ECHO StartCmd:self_define_cmd_checkinfo>>%LOG_FILE%
@ECHO version:%GRAB_VERSION%>>%LOG_FILE%
@ECHO EndCmd:self_define_cmd_checkinfo>>%LOG_FILE%
@ECHO ###########################################################################>>%LOG_FILE%
@ECHO Progress: 100%%	LOG Path: %~dp0%LOG_FILE%

@pause