# coding=utf-8
__author__ = '******'
# 获取linux主机的一些基础信息:名称、版本、CPU、内存等.
import re
import sys
import os 
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..")
sys.path.append(path)
from common import constants
from common import util
CLI = None
LANGUAGE = None
CHECK_FAIL          =       0
CHECK_PASS          =       1
cmd_info_id = ["cmd_info_database_objectchange",
               "cmd_info_database_sqlplus",

               ]
            
cmd_info_desc = ["su - oracle",
                 "sqlplus / as sysdba",
                 
                 ]

sql_info = {"sql_info_cluster_ora_cversion"      :       "select * from v$version;",
            "sql_info_cluster_ora_diskgroup"     :       "select group_number,name,state,total_mb from v$asm_diskgroup;",
            "sql_info_cluster_ora_asmdisk"       :       "select group_number,name,path from v$asm_disk;",
            }

def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    # 给全局变量赋初始值，按照要求传递上下文进去。
    global CLI
    CLI = context.get("SSH")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    cmd_display = context.get("ret_map")
    return check_and_get_result(cmd_execute(context, cmd_display, CLI, LANGUAGE))


# 取中间一个有效值
def check_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result


def cmd_execute(context, cmd_display, CLI, LANGUAGE):
    tempStep = constants.PROG25 / len(cmd_info_id)
    curStep = tempStep
    fun_flag = CHECK_FAIL
    sql_flag = True
    oracle_flag=True
    fun_err_msg = ''
    for rg in range(len(cmd_info_id)):
        cmd_display_temp = CLI.execCmdHasLogTimout(cmd_info_desc[rg],60)
        curStep += tempStep
        util.updateItemProgress(context, curStep)
        cmd_display.put("cmd_display"+(cmd_info_id[rg])[8:], cmd_display_temp)
        if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
            if "en"==LANGUAGE:
                fun_err_msg        +=cmd_info_desc[rg] + ":\texecute failed\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + u":\t执行失败\r\n"
        else:
            if "en"==LANGUAGE:
                fun_err_msg        +=cmd_info_desc[rg] + ":\texecute success\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + u":\t执行成功\r\n"

        if cmd_display_temp.find('not-found') > 0 or cmd_display_temp.find('not found') > 0 or cmd_display_temp.find('is not valud for this command') > 0:
            sql_flag = False
        if cmd_info_desc[rg] == "su - oracle" and 'User "oracle" does not exist' in cmd_display_temp :
            oracle_flag = False
        if cmd_info_desc[rg] == "sqlplus / as sysdba" and "SQL>".lower() not in cmd_display_temp.lower():
            sql_flag = False
    cmd_display.put("err_msg", fun_err_msg)
    if oracle_flag and not sql_flag:
        CLI.execDbCmdNoLogTimout("exit", 60)
    if sql_flag:
        tempStep = constants.PROG65 / len(sql_info)
        curStep = constants.PROG25
        for item in sql_info:
            curStep += tempStep
            util.updateItemProgress(context, curStep)
            cmd_display_temp = CLI.execDbCmdNoLogTimout(sql_info.get(item),60)
            cmd_display.put("sql_display"+(item)[8:], cmd_display_temp)
            if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
                if "en"==LANGUAGE:
                    fun_err_msg        +=sql_info.get(item) + ":\texecute failed\r\n"
                else:
                    fun_err_msg += sql_info.get(item) + u":\t执行失败\r\n"
            else:
                if "en"==LANGUAGE:
                    fun_err_msg        +=sql_info.get(item) + ":\texecute success\r\n"
                else:
                    fun_err_msg += sql_info.get(item) + u":\t执行成功\r\n"
        cmd_display.put("err_msg", fun_err_msg)
        #退出数据库
        CLI.execDbCmdNoLogTimout("exit", 60)
        CLI.execDbCmdNoLogTimout("exit", 60)
    fun_flag = CHECK_PASS

    return fun_flag, cmd_display, fun_err_msg