# coding=utf-8
__author__ = '******'
# 获取linux主机的多路径信息
import re
import sys
import os 
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..")
sys.path.append(path)
from common import constants
from common import util
CLI = None
LANGUAGE = None
CHECK_FAIL          =       0
CHECK_PASS          =       1
cmd_info_id = []
            
cmd_info_desc = []
                 


cmd_multipath_EMC_id = ['cmd_info_multipath_version_EMC', 'cmd_info_multipath_path_EMC']
cmd_multipath_EMC_desc = ['powermt version', 'powermt display dev=all']

cmd_multipath_IBM_id = [ 'cmd_info_multipath_path_IBM']
cmd_multipath_IBM_desc = [ 'pcmpath query device']

cmd_multipath_id = cmd_multipath_EMC_id + cmd_multipath_IBM_id
cmd_multipath_desc = cmd_multipath_EMC_desc + cmd_multipath_IBM_desc



def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    #给全局变量赋初始值，按照要求传递上下文进去。
    global CLI
    CLI = context.get("SSH")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    cmd_display = context.get("ret_map")
    
    check_and_get_result(cmd_storage_execute(context, cmd_display, CLI, LANGUAGE, cmd_multipath_id, cmd_multipath_desc))
    return check_and_get_result(cmd_execute(context, cmd_display, CLI, LANGUAGE))
    


# 取中间一个有效值
def check_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result
    
# 取一个有效值
def check_storage_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result
    
def cmd_storage_execute(context, cmd_display, CLI, LANGUAGE, cmd_info_id, cmd_info_desc):
    tempStep = constants.PROG60 / len(cmd_info_id)
    curStep = tempStep
    fun_flag = CHECK_FAIL
    fun_err_msg = ''
    for rg in range(len(cmd_info_id)):
        curStep += tempStep
        util.updateItemProgress(context, curStep)
        cmd_display_temp = CLI.execCmdHasLogTimout(cmd_info_desc[rg], 60)
        if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
            continue
        else:
            cmd_display.put("cmd_display" + (cmd_info_id[rg])[8:], cmd_display_temp)
            if "en" == LANGUAGE:
                fun_err_msg += cmd_info_desc[rg] + ":\texecute success\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + u":\t执行成功\r\n"
    cmd_display.put("err_msg", fun_err_msg);
    fun_flag = CHECK_PASS
    return fun_flag, cmd_display, fun_err_msg


def cmd_execute(context, cmd_display, CLI, LANGUAGE):
    util.updateItemProgress(context, constants.PROG80)
    fun_flag = CHECK_FAIL
    fun_err_msg = ''
    for rg in range(len(cmd_info_id)):
        cmd_display_temp = CLI.execCmdHasLogTimout(cmd_info_desc[rg],60)
        cmd_display.put("cmd_display"+(cmd_info_id[rg])[8:], cmd_display_temp)
        if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
            if "en"==LANGUAGE:
                fun_err_msg        +=cmd_info_desc[rg] + ":\texecute failed\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + u":\t执行失败\r\n"
        else:
            if "en"==LANGUAGE:
                fun_err_msg        +=cmd_info_desc[rg] + ":\texecute success\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + u":\t执行成功\r\n"
    cmd_display.put("err_msg", fun_err_msg  + cmd_display.get("err_msg"))
    fun_flag = CHECK_PASS
    return fun_flag, cmd_display, fun_err_msg