# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst = ["server_model","cpu_model","memory","os","multipath","cluster","lvm/vxvm","database"]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #属性名与对应命令列表组成的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    for key in key_lst:
        tempList = []
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
                tempList = attr_valuelst_dic[attr]
                value = get_value_bykey(tempList,key)
                value_lst.append(value)
    #获取json结果字符串                 
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context


#功能说明：返回属性名与对应回文组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)

 
#功能说明：返回Server model
def get_servermodel(tempList):
    if 0==len(tempList):
        return 'NA'
    
    length = len(tempList)
    index = 0 
    for i in range(length):
        if "uname -a" in tempList[i]:
            index = i +1
            break
    result = tempList[index]
    ret_lst = re.split(' ',result)
    result = ret_lst[0]+' '+ret_lst[1] +' '+ret_lst[2] 
    return result

#功能说明：返回CPU model    
def get_cpumodel(tempList):
    #架构 厂商，位数。如：x86-64 AMD64
    arch = 'NA'
    vendor = 'NA'
    osbit = 'NA'
    result = ""
    
    if 0==len(tempList):
        return 'NA'
    tempList = checktempList(tempList)
    
    for i,line in enumerate(tempList):
        if ('uname' in line.lower()) and ('-a' in line.lower()):
            if 'x86_64' in tempList[i+1].lower():
                osbit = '64'
                arch = tempList[i+1]
                lst = re.split('\\s+',arch)
                arch = lst[-2].strip()
            else:
                osbit = '32'
                arch = tempList[i+1]
                lst = re.split('\\s+',arch)
                arch = lst[-2].strip()
    for line in tempList:
        if ('vendor' in line.lower()) and ('id' in line.lower()):
            vendor = line.split(':')[-1].strip()
            break
    result = arch+' '+vendor+osbit
    return result 

#功能说明：返回Memory
def get_memory(tempList):
    if 0==len(tempList):
        return 'NA'
    
    result = ""
    for i in range(len(tempList)):
        if "MemTotal" in tempList[i].strip():
            tempStr = tempList[i]
    total_mem = tempStr.replace(':', ' ').replace('MemTotal', ' ').strip()
    total = '' + str(round(float(total_mem.replace("kB", '')) / 1024 / 1024, 2)) + "GB"
    result = total
    if '' ==result.strip():
        result ="NA"
    return result 

#功能说明：返回Multipath name
def get_multipath(tempList):
    multipath_name = 'NA'
    
    if 0 == len(tempList):
        return  multipath_name
    
    txtList = []
    index = 0
    for i,line in enumerate(tempList):
        if divide in line:
            txtList.append(tempList[index:i])
            index = i + 1
    
    failStr = fail_flag
    
    resultTxt = []
    
    for txtBlock in txtList:
        flag = True
        for line in txtBlock:
            if failStr.lower() in line.lower():
                flag = False
                break
        if flag:
            resultTxt = txtBlock
            
    if len(resultTxt) == 0:
         
        return multipath_name
    
    for line in resultTxt:
        if 'powermt' in line:
            multipath_name= 'PowerPath'
        if ('upadmin' in line) and ('show' in line):
            multipath_name= 'UltraPath'
        if 'dlnkmgr' in line:
            multipath_name= 'HDLM'
        if 'upadm' in line:
            multipath_name= 'UltraPath'
        if ('lslpp' in line) and ('grep' in line) and ('sddpcm' in line):
            multipath_name= 'IBM'
        if ('multipath' in line):
            multipath_name = "Multipath"
    return multipath_name
    
#功能说明：返回cluster
def get_cluster(tempList):
    result = ""
    
    if 0==len(tempList):
        return 'NA'
    
    result = '\\n'.join(tempList[1:-1])
    return result
    

#功能说明：返回lvm/vxvm
def get_lvm(tempList):
    result = ""
    
    if 0==len(tempList):
        return 'NA'
    
    for i,value in enumerate(tempList):
        if ('lvm' in value.lower()) and ('version:' in value.lower()):
            result = tempList[i]
            break
    result = result.split(':')[1].strip()
    if ""!= result.lower():
        return result
    
    result = '\\n'.join(tempList[1:-1])
    return result 

#功能说明：返回database
def get_database(tempList):
    result = ""
    if 0==len(tempList):
        return 'NA'
    else:
        result = '\\n'.join(tempList[1:-1])
    return result 


#功能说明：返回OS
def get_os(tempList):
    if 0==len(tempList):
        return 'NA'
    
    result = ""
    op_sys_info=""
    dev_type=""
    for t in range(len(tempList)):
        op_sys_info=op_sys_info+tempList[t]+'\n'

    tem_line = op_sys_info.splitlines()
    if 'Asianux' in op_sys_info:
        for i in range(0, len(tem_line)):
            #####################     Suse Area    #####################
            if 'Asianux' in tem_line[i]:
                dev_type = 'Asianux ' + tem_line[i].split()[2]
                break
    elif 'Debian' in op_sys_info:
        for i in range(0, len(tem_line)):
            if 'Debian' in tem_line[i]:
                dev_type = 'Debian ' + tem_line[i].split()[2]
                break
    elif 'Oracle Linux' in op_sys_info:
        for i in range(0, len(tem_line)):
            if 'Oracle Linux' in tem_line[i]:
                dev_type = 'Oracle Linux ' + tem_line[i].split()[4]
                break
    elif 'SUSE' in op_sys_info:        
        for i in range(0,len(tem_line)):
            if 'VERSION' in tem_line[i]:
                version = tem_line[i].split('=')[1].strip()
                dev_type = 'SUSE '+version
            if 'PATCHLEVEL' in tem_line[i]:
                level = tem_line[i].split('=')[1].strip()
                dev_type = dev_type + ' ' + 'SP' + level
                break
    #####################   Red Hat Area    #####################
    elif 'Red Hat' in op_sys_info:
        for i in range(0, len(tem_line)):
            if 'Red Hat' in tem_line[i] and "=" not in tem_line[i]:
                dev_type = "Red Hat " + tem_line[i].split()[6]
                break
    #####################   CentOS Area    #####################
    elif 'CentOS' in op_sys_info: 
        for i in range(0, len(tem_line)):
            if 'CentOS' in tem_line[i]:
                dev_type = "CentOS " + tem_line[i].split()[2]
                if dev_type == 'CentOS release':
                    dev_type = "CentOS " + tem_line[i].split()[3]
                break
    #####################   XenServer Area    #####################
    elif 'XenServer' in op_sys_info:
        for i in range(0, len(tem_line)):
            if 'XenServer' in tem_line[i]:
                dev_type = "XenServer " + tem_line[i].split()[3];
                break
            #####################   Ubuntu Area    #####################
    elif 'Ubuntu' in op_sys_info:
        for i in range(0, len(tem_line)):
            if 'Ubuntu' in tem_line[i]:
                dev_type = ""
                resultList=tem_line[i].split()
                dev_type = resultList[0]+resultList[1]
                break
    
    result=dev_type
    if ""==result.strip():
        result = "not found"
    return result

def get_value_bykey(tempList,key):
    if key == key_lst[0]:
        return get_servermodel(tempList)
    elif key == key_lst[1]:
        return get_cpumodel(tempList)
    elif key == key_lst[2]:
        return get_memory(tempList)
    elif key == key_lst[3]:
        return get_os(tempList)
    elif key == key_lst[4]:
        return get_multipath(tempList)
    elif key == key_lst[5]:
        return get_cluster(tempList)
    elif key == key_lst[6]:
        return get_lvm(tempList)
    elif key == key_lst[7]:
        return get_database(tempList)
    else:
        return "Key Error"
