# coding=utf-8
# 获取windows WFSC集群相关信息
import sys
import os
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..")
sys.path.append(path)
from common import constants,util,contentParse

cmd_info_id = ['cmd_info_ClusterResource_info',
               'cmd_info_ClusterQuorum_info',
               'cmd_info_ClusterSharedVolume_info',
               'cmd_info_ClusterSharedVolumeState_info',
               'cmd_info_Clusternode_info',
               'cmd_info_ClusterGroup_info']
cmd_info_desc = ['powershell Get-ClusterResource',
                 'powershell Get-ClusterQuorum',
                 'powershell Get-ClusterSharedVolume',
                 'powershell Get-ClusterSharedVolumeState',
                 'powershell Get-Clusternode',
                 'powershell Get-ClusterGroup']
cmd_info_dic = dict(zip(cmd_info_id,cmd_info_desc))
CLI = None
LANGUAGE = None
def execute(context):

    global CLI
    CLI = context.get("SSH")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    cmd_display = context.get("ret_map")

    return cmd_execute(cmd_display, CLI, LANGUAGE, context,cmd_info_dic)

def cmd_execute(cmd_display, CLI, LANGUAGE, context,cmd_info_dict):
    if len(cmd_info_dict) > 0:
        fun_err_msg = ''
        prgStep = constants.PROG85 / len(cmd_info_dict)
        curstep = constants.PROG5
        util.updateItemProgress(context, curstep)
        for cmd_info_id,cmd_info_desc in cmd_info_dict.items():
            try:
                cmd_display_temp = CLI.executeCmdTimeoutLcalWmic(cmd_info_desc,60)
            except :
                cmd_display_temp = CLI.execCmd(cmd_info_desc)
            curstep += prgStep
            util.updateItemProgress(context, curstep)
            cmd_display.put("cmd_display" + cmd_info_id[8:], cmd_display_temp)
            if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 \
                    or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
                if "en" == LANGUAGE:
                    fun_err_msg += cmd_info_desc + ":\texecute failed\r\n"
                else:
                    fun_err_msg += cmd_info_desc + u":\t执行失败\r\n"
            else:
                if "en" == LANGUAGE:
                    fun_err_msg += cmd_info_desc + ":\texecute success\r\n"
                else:
                    fun_err_msg += cmd_info_desc + u":\t执行成功\r\n"
        cmd_display.put("err_msg", fun_err_msg)
        return  cmd_display
    else:
        return ""



