# =================================================================
# NetApp connection constants:
#   referred to netApp manage on-tap sdk
# ==================================================================


class NetAppConstants:

    def __init__(self):
        """
        blank
        """
    NETAPP_ELEMENT_NETAPP = "netapp"
    CONNECTION_TYPE_HTTP = 'HTTP'
    CONNECTION_TYPE_HTTPS = 'HTTPS'
    COMMON_CONNECTION_PROTOCALS = [CONNECTION_TYPE_HTTP, CONNECTION_TYPE_HTTPS]


    NETAPP_SERVER_TYPE_OCUM = 'OCUM'
    NETAPP_SERVER_TYPE_FILER = 'FILER'
    NETAPP_SERVER_TYPE_DFM = 'DFM'
    NETAPP_SERVER_TYPE_NETCACHE = 'NETCACHE'
    NETAPP_SERVER_TYPE_AGENT = 'AGENT'
    NETAPP_SERVER_TYPES = [NETAPP_SERVER_TYPE_OCUM,
                           NETAPP_SERVER_TYPE_FILER,
                           NETAPP_SERVER_TYPE_DFM,
                           NETAPP_SERVER_TYPE_NETCACHE,
                           NETAPP_SERVER_TYPE_AGENT]

    NETAPP_SIGN_IN_METHOD_HOSTS = 'HOSTS'
    NETAPP_SIGN_IN_METHOD_LOGIN = 'LOGIN'
    NETAPP_SIGN_IN_METHOD_CERTIFICATE = 'CERTIFICATE'
    NETAPP_SIGN_IN_METHODS = [NETAPP_SIGN_IN_METHOD_HOSTS,
                              NETAPP_SIGN_IN_METHOD_LOGIN,
                              NETAPP_SIGN_IN_METHOD_CERTIFICATE]
    NETAPP_SERVER_URLS = {
                            NETAPP_SERVER_TYPE_OCUM:     "/apis/XMLrequest",
                            NETAPP_SERVER_TYPE_FILER:    "/servlets/netapp.servlets.admin.XMLrequest_filer",
                            NETAPP_SERVER_TYPE_DFM:      "/apis/XMLrequest",
                            NETAPP_SERVER_TYPE_NETCACHE: "/servlets/netapp.servlets.admin.XMLrequest",
                            NETAPP_SERVER_TYPE_AGENT:    "/apis/XMLrequest"
                          }
    NETAPP_SERVER_DTDS = {
                            NETAPP_SERVER_TYPE_OCUM:     "file:/etc/netapp_dfm.dtd",
                            NETAPP_SERVER_TYPE_FILER:    "file:/etc/netapp_filer.dtd",
                            NETAPP_SERVER_TYPE_DFM:      "file:/etc/netapp_dfm.dtd",
                            NETAPP_SERVER_TYPE_NETCACHE: "file:/etc/netapp_filer.dtd",
                            NETAPP_SERVER_TYPE_AGENT:    "file:/etc/netapp_agent.dtd"
                          }
    NETAPP_SERVER_DEFAULT_PORT = {
                            NETAPP_SERVER_TYPE_OCUM:     "443",
                            NETAPP_SERVER_TYPE_FILER:    "443",
                            NETAPP_SERVER_TYPE_DFM:      "8088",
                            NETAPP_SERVER_TYPE_NETCACHE: "80",
                            NETAPP_SERVER_TYPE_AGENT:    "4092"
                          }
    NETAPP_DEBUG_STYLE = "NA_PRINT_DONT_PARSE"

    HTTP_CONN_CODE_UNAUTHORIZED = 401
